//Jeff DeMaagd (c)1999
// defines the input and output operations for DXF

#include "dxf.h"

// *************************************************************************
//DXF DXF::operator= (const DXF dxf_read)
//{
//	return dxf_read;
//}

// *************************************************************************
//bool DXF::operator== (DXF & dxf_read)
//{
//	return false;
//}

// *************************************************************************
// dxf_record input function

istream & operator >> (istream & input,	dxf_record & rec)
{
	char tempch;

	rec.type = 0;		rec.record = "";
	rec.integer = 0;	rec.doub = 0;

	input >> rec.type;
	
//	cout << "Integer:\t" << rec.type << endl;

					// strings
	if ((rec.type < 10) || (rec.type == 100) || 
	   ((rec.type > 1998) && (rec.type < 1010))) {

		tempch = input.peek();		// tried to fix for UNIX
		if (tempch == 0x0D)		// style files.
			tempch = input.get();
//			cout << "0x0D ";
//		if (tempch == 0x0A) {
			tempch = input.get();
//			cout << "0x0A ";
//		}
		tempch = input.get();

//		tempch = input.get();
//		tempch = input.get();
//		tempch = input.get();
		while ((tempch != (char)10) && (tempch != (char)13)) {
			rec.record += tempch;
			tempch = input.get();
		}
		if (tempch == 0x0D)
			tempch = input.get();	
	}
							// integers
	else if (((rec.type >   59) && (rec.type <   80)) ||
		 ((rec.type >  169) && (rec.type <  176)) || 
		 ((rec.type > 1059) && (rec.type < 1080)))	{
		 input >> rec.integer;
							// floats
	} else if ((rec.type <   60) ||
		   ((rec.type >  169) && (rec.type <  176)) || 
		   ((rec.type > 1059) && (rec.type < 1080)))
		 input >> rec.doub;
	else	{
		input >> rec.record;
		cerr 	<< "Error on read:  A bad or unsupported value was used.\n"
			<< "Report errors to Jeff DeMaagd <jdemaa17@calvin.edu>.  Thank you.\n"; 
	} 
	
	return input;
}

// *************************************************************************
// dxf_record output function

ostream & operator << (ostream & output, dxf_record & rec)
{
				// reproduce AutoCAD's  spacings.
//	if (rec.type <  10)	output << " ";
//	if (rec.type < 100)	output << " ";
//	output.right();

	output << setw(3) << rec.type << endl;			//record type ID
							// strings
	if ((rec.type < 10) || ((rec.type > 1998) && (rec.type < 1010)))
		output << rec.record << endl;
							// integers
	else if (((rec.type >   59) && (rec.type <   80)) ||
		 ((rec.type >  169) && (rec.type <  176)) || 
		 ((rec.type > 1059) && (rec.type < 1080)))
		 output << rec.integer << endl;
							// floats
	else if ((rec.type <   59) ||
		 ((rec.type >  169) && (rec.type <  176)) || 
		 ((rec.type > 1059) && (rec.type < 1080)))
		 output << rec.doub << endl;
	else	{
		cerr << "Error on write:  A bad or unsupported value was used.\n"
			<< "The output may not make sense to other programs.\n"
			<< "Be suspicios of this programs input and output.\n"
			<< "If you believe the input or output to be accurate,\n"
			<< "and the bug is reproducible, send a sample data file to\n"
			<< "Jeff DeMaagd <jdemaa17@calvin.edu>.  Thank you.\n"; 
	}
	 
	return output;
}

// *************************************************************************
istream & operator>> (istream & input, data_node & element)
{
	return input;
}

// *************************************************************************
ostream & operator<< (ostream & output, data_node & element)
{
//	output << showpoint << fixed;	// unsupported by g++
	
	if (element.geomtype == DXF_POINT)	{
		output << "  0" << DNL << "POINT"			<< DNL;
		output << "  5" << DNL << element.handle		<< DNL; 
		if (element.layer != "")
			output << "  8" << DNL << element.layer		<< DNL; 
		if (element.color != 0)
			output << " 62" << DNL << element.color		<< DNL; 
		output << " 10" << DNL << element.geom.point.x		<< DNL;
		output << " 20" << DNL << element.geom.point.y		<< DNL;
		output << " 30" << DNL << element.geom.point.z		<< DNL;

	} else if (element.geomtype == DXF_LINE)	{
		output << "  0" << DNL << "LINE"			<< DNL;
		output << "  5" << DNL << element.handle		<< DNL; 
		if (element.layer != "")
			output << "  8" << DNL << element.layer		<< DNL; 
		if (element.color != 0)
			output << " 62" << DNL << element.color		<< DNL; 
		output << " 10" << DNL << element.geom.line.p1.x	<< DNL;
		output << " 20" << DNL << element.geom.line.p1.y	<< DNL;
		output << " 30" << DNL << element.geom.line.p1.z	<< DNL;
		output << " 11" << DNL << element.geom.line.p2.x	<< DNL;
		output << " 21" << DNL << element.geom.line.p2.y	<< DNL;
		output << " 31" << DNL << element.geom.line.p2.z	<< DNL;

	} else if (element.geomtype == DXF_CIRCLE)	{
		output << "  0" << DNL << "CIRCLE"			<< DNL;
		output << "  5" << DNL << element.handle		<< DNL; 
		if (element.layer != "")
			output << "  8" << DNL << element.layer		<< DNL; 
		if (element.color != 0)
			output << " 62" << DNL << element.color		<< DNL; 
		output << " 10" << DNL << element.geom.circle.p1.x	<< DNL;
		output << " 20" << DNL << element.geom.circle.p1.y	<< DNL;
		output << " 30" << DNL << element.geom.circle.p1.z	<< DNL;
		output << " 40" << DNL << element.geom.circle.r1	<< DNL;

	} else if (element.geomtype == DXF_ARC)	{
		output << "  0" << DNL << "ARC"				<< DNL;
		output << "  5" << DNL << element.handle		<< DNL; 
		if (element.layer != "")
			output << "  8" << DNL << element.layer		<< DNL; 
		if (element.color != 0)
			output << " 62" << DNL << element.color		<< DNL; 
		output << " 10" << DNL << element.geom.arc.p1.x		<< DNL;
		output << " 20" << DNL << element.geom.arc.p1.y		<< DNL;
		output << " 30" << DNL << element.geom.arc.p1.z		<< DNL;
		output << " 40" << DNL << element.geom.arc.r1		<< DNL;
		output << " 50" << DNL << element.geom.arc.a1		<< DNL;
		output << " 51" << DNL << element.geom.arc.a2		<< DNL;
	} else if (element.geomtype == DXF_3DFACE)	{
		output << "  0" << DNL << "3DFACE"			<< DNL;
		output << "  5" << DNL << element.handle		<< DNL; 
		if (element.layer != "")
			output << "  8" << DNL << element.layer		<< DNL; 
		if (element.color != 0)
			output << " 62" << DNL << element.color		<< DNL; 
		output << " 10" << DNL << element.geom.quad.p1.x	<< DNL;
		output << " 20" << DNL << element.geom.quad.p1.y	<< DNL;
		output << " 30" << DNL << element.geom.quad.p1.z	<< DNL;

		output << " 11" << DNL << element.geom.quad.p2.x	<< DNL;
		output << " 21" << DNL << element.geom.quad.p2.y	<< DNL;
		output << " 31" << DNL << element.geom.quad.p2.z	<< DNL;

		output << " 12" << DNL << element.geom.quad.p3.x	<< DNL;
		output << " 22" << DNL << element.geom.quad.p3.y	<< DNL;
		output << " 32" << DNL << element.geom.quad.p3.z	<< DNL;

		output << " 12" << DNL << element.geom.quad.p4.x	<< DNL;
		output << " 22" << DNL << element.geom.quad.p4.y	<< DNL;
		output << " 32" << DNL << element.geom.quad.p4.z	<< DNL;
	} else if (element.geomtype == DXF_TEXT)	{
		output << "  0" << DNL << "TEXT"			<< DNL;
		output << "  5" << DNL << element.handle		<< DNL; 
		if (element.layer != "")
			output << "  8" << DNL << element.layer		<< DNL; 
		if (element.color != 0)
			output << " 62" << DNL << element.color		<< DNL; 
		output << " 10" << DNL << element.geom.text.p1.x	<< DNL;
		output << " 20" << DNL << element.geom.text.p1.y	<< DNL;
		output << " 30" << DNL << element.geom.text.p1.z	<< DNL;

		output << " 40" << DNL << element.geom.text.height	<< DNL;

		output << "  1" << DNL << element.geom.text.t1		<< DNL;

		if (element.geom.text.a1 != 0)
			output << " 50" << DNL << element.geom.text.a1	<< DNL;

		if (element.geom.text.flag != 1)
			output << " 41" << DNL << element.geom.text.xscale << DNL;

		if (element.geom.text.flag != 0)
			output << " 71" << DNL << element.geom.text.flag << DNL;

		if (element.geom.text.just != 0)	{
			output << " 72" << DNL << element.geom.text.just << DNL;
			output << " 11" << DNL << element.geom.text.p2.x << DNL;
			output << " 21" << DNL << element.geom.text.p2.y << DNL;
			output << " 31" << DNL << element.geom.text.p2.z << DNL;
		}

	}
	return output;
}

// *************************************************************************
istream & operator>> (istream & input, DXF & dxf)
{
	dxf_record temprec;
	data_node tempnode;
	int unsupported = 0;		// on my system, a bool takes 8 bytes
					// sick, eh?  This takes 4 bytes.
	input >> temprec;

	while (temprec.record != "ENTITIES")	// skip to entity sec
			input >> temprec;

	input >> temprec;	// this should start a new entity
	
	
	while ((temprec.type == 0)	&& (temprec.record != "ENDSEC")) {
		unsupported = 0;
		if (temprec.record == "ARC")
			tempnode.geomtype = DXF_ARC;
		else if (temprec.record == "LINE")
			tempnode.geomtype = DXF_LINE;
		else if (temprec.record == "3DFACE")
			tempnode.geomtype = DXF_3DFACE;
		else if (temprec.record == "CIRCLE")
			tempnode.geomtype = DXF_CIRCLE;
		else if (temprec.record == "POINT")
			tempnode.geomtype = DXF_POINT;
		else if (temprec.record == "TEXT")
			tempnode.geomtype = DXF_TEXT;
		else {
			cerr	<< "Unsupported object type: " 
				<< temprec.type << "\t" << temprec.record << endl;
			unsupported = 1;	
		}

		input >> temprec;

		if (unsupported == 1) {
			while (temprec.type != 0)	{
				cerr	<< "Unsupported object type: " 
					<< temprec.type << "\t" << temprec.record << endl;
				input >> temprec;
			}
		} else {
			if (temprec.type == 5)	{
				tempnode.handle = temprec.record;
				input >> temprec;
			}
				
					// idiotic type '100' elimination
			if (temprec.type == 100)
				input >> temprec;
				
			if (temprec.type == 6)	{
				tempnode.linetype = temprec.record;
				input >> temprec;
			}
				
					// idiotic type '100' elimination
			if (temprec.type == 100)
				input >> temprec;
				
			if (temprec.type == 8)	{
				tempnode.layer = temprec.record;
				input >> temprec;
			}

			if (temprec.type == 62)	{
				tempnode.color = temprec.integer;
				input >> temprec;
			}

					// idiotic type '100' elimination
			if (temprec.type == 100)
				input >> temprec;

			if (tempnode.geomtype == DXF_ARC)	{
//				cout << "Read in an arc.\n";

				tempnode.geom.arc.p1.x = temprec.doub;	//10
				input >> temprec;
				tempnode.geom.arc.p1.y = temprec.doub;	//20
				input >> temprec;
				tempnode.geom.arc.p1.z = temprec.doub;	//30
				input >> temprec;

				tempnode.geom.arc.r1 = temprec.doub;	//40
				input >> temprec;

					// idiotic type '100' elimination
				if (temprec.type == 100)
					input >> temprec;

				tempnode.geom.arc.a1 = temprec.doub;	//50
				input >> temprec;
				tempnode.geom.arc.a2 = temprec.doub;	//51
				input >> temprec;

			} else if (tempnode.geomtype == DXF_LINE)	{
//				cout << "Read in a line.\n";

				tempnode.geom.line.p1.x = temprec.doub;	//10
				input >> temprec;
				tempnode.geom.line.p1.y = temprec.doub;	//20
				input >> temprec;
				tempnode.geom.line.p1.z = temprec.doub;	//30
				input >> temprec;

				tempnode.geom.line.p2.x = temprec.doub;	//10
				input >> temprec;
				tempnode.geom.line.p2.y = temprec.doub;	//20
				input >> temprec;
				tempnode.geom.line.p2.z = temprec.doub;	//30
				input >> temprec;
				

			} else if (tempnode.geomtype == DXF_3DFACE)	{
//				cout << "Read in a 3D face.\n";
		
				tempnode.geom.quad.p1.x = temprec.doub;	//10
				input >> temprec;
				tempnode.geom.quad.p1.y = temprec.doub;	//20
				input >> temprec;
				tempnode.geom.quad.p1.z = temprec.doub;	//30
				input >> temprec;

				tempnode.geom.quad.p2.x = temprec.doub;	//11
				input >> temprec;
				tempnode.geom.quad.p2.y = temprec.doub;	//21
				input >> temprec;
				tempnode.geom.quad.p2.z = temprec.doub;	//31
				input >> temprec;
				
				tempnode.geom.quad.p3.x = temprec.doub;	//12
				input >> temprec;
				tempnode.geom.quad.p3.y = temprec.doub;	//22
				input >> temprec;
				tempnode.geom.quad.p3.z = temprec.doub;	//32
				input >> temprec;
			
				tempnode.geom.quad.p4.x = temprec.doub;	//13
				input >> temprec;
				tempnode.geom.quad.p4.y = temprec.doub;	//23
				input >> temprec;
				tempnode.geom.quad.p4.z = temprec.doub;	//33
				input >> temprec;
				
			} else if (tempnode.geomtype == DXF_POINT)	{
//				cout << "Read in a point.\n";
				tempnode.geom.point.x = temprec.doub;	//10
				input >> temprec;
				tempnode.geom.point.y = temprec.doub;	//20
				input >> temprec;
				tempnode.geom.point.z = temprec.doub;	//30
				input >> temprec;

			} else if (tempnode.geomtype == DXF_TEXT)	{
//				cout << "Read in a point.\n";
				tempnode.geom.text.p1.x = temprec.doub;	//10
				input >> temprec;
				tempnode.geom.text.p1.y = temprec.doub;	//20
				input >> temprec;
				tempnode.geom.text.p1.z = temprec.doub;	//30
				input >> temprec;

				tempnode.geom.text.height = temprec.doub; //40
				input >> temprec;

							// null out text array
				for (unsigned int i = 0; i < 64; i++)
					tempnode.geom.text.t1[i] = 0;
					
							//1
				for (unsigned int i = 0; i < temprec.record.size(); i++)
					tempnode.geom.text.t1[i] = temprec.record[i];
				input >> temprec;

				if (temprec.type == 50) {	//rotation ang
					tempnode.geom.text.a1 = temprec.doub;
					input >> temprec;
				} else
					tempnode.geom.text.a1 = 0;

				if (temprec.type == 41) {
					tempnode.geom.text.xscale = temprec.doub;
					input >> temprec;
				} else
					tempnode.geom.text.xscale = 1;


				if (temprec.type == 51) {	//obliqing (skew) ang
					tempnode.geom.text.a2 = temprec.doub;
					input >> temprec;
				} else
					tempnode.geom.text.a2 = 0;

				if (temprec.type == 71) {	//obliqing (skew) ang
					tempnode.geom.text.flag = temprec.integer;
					input >> temprec;
				} else
					tempnode.geom.text.flag = 0;

				if (temprec.type == 72) {	//obliqing (skew) ang
					tempnode.geom.text.just = temprec.doub;
					input >> temprec;
				} else
					tempnode.geom.text.just = 0;

				if (temprec.type == 11) {
					tempnode.geom.text.p2.x = temprec.doub;
					input >> temprec;
					tempnode.geom.text.p2.y = temprec.doub;
					input >> temprec;
					tempnode.geom.text.p2.z = temprec.doub;
					input >> temprec;
				} else {
					tempnode.geom.text.p2.x = 0;
					tempnode.geom.text.p2.y = 0;
					tempnode.geom.text.p2.z = 0;
				}


					// idiotic type '100' elimination
				if (temprec.type == 100)
					input >> temprec;

			} else if (tempnode.geomtype == DXF_CIRCLE)	{
//				cout << "Read in a circle.\n";
				tempnode.geom.circle.p1.x = temprec.doub; //10
				input >> temprec;
				tempnode.geom.circle.p1.y = temprec.doub; //20
				input >> temprec;
				tempnode.geom.circle.p1.z = temprec.doub; //30
				input >> temprec;

				tempnode.geom.arc.r1 = temprec.doub;	//40
				input >> temprec;

			}
			dxf.data_list.push_back(tempnode);
		}		
	}
	return input;
}

// *************************************************************************
ostream & operator<< (ostream & output, const DXF & dxf_write)
{
	output << "  0" << DNL << "SECTION"	<< DNL;
	output << "  2" << DNL << "ENTITIES"	<< DNL;
	for (vector<data_node>::iterator it 
		= dxf_write.data_list.begin();
		it < dxf_write.data_list.end(); it++)
		cout << *it;
	output << "  0" << DNL << "ENDSEC"	<< DNL;
	output << "  0" << DNL << "EOF"		<< DNL;
	return output;
}
