//Jeff DeMaagd (c)1999

#include <stdio.h>
#include <string.h>
#include "dxf.h"



// *************************************************************************
int read_dxf_drecord(void)
// reads in a two line 'record' in a DXF file
{
	extern int dxf_number;		//integer that preceeds the data value
	extern double dxf_double;
	extern FILE *file_in;

	printf ("\t\tread_dxf_drecord() entered.\n");

	fscanf (file_in, "%i", &dxf_number);
	printf ("\t\tread dxf_number:\t%i", dxf_number);

	fscanf (file_in, "%lf", &dxf_double);
	printf ("\t%f\n", dxf_double);

	printf ("\t\tread_dxf_drecord() exited.\n");

	return 0;
}

// *************************************************************************
int read_dxf_record(void)
// reads in a two line 'record' in a DXF file
{
	extern int dxf_number;		//integer that preceeds the data value
	extern char dxf_record[32];	//this size for safety
	extern double dxf_double;
	extern FILE *file_in;

	printf ("\t\tread_dxf_record() entered.\n");
	
//	if (file_in == NULL)
//		printf ("\nFile is not opened properly\n");
		
	fscanf (file_in, "%i", &dxf_number);
	printf ("\t\tread dxf_number:\t%i", dxf_number);
	
	if (dxf_number < 10) {				//   0 - 9   string
		fscanf (file_in, "%s",	dxf_record);
		printf ("\t%s", dxf_record);
	} else if (dxf_number < 60) {			//  10 - 59  fp
		fscanf (file_in, "%lf", &dxf_double);
		printf ("\t%f", dxf_double);
	} else if (dxf_number < 80) {			//  60 - 70  int
		fscanf (file_in, "%i",	&dxf_int);
		printf ("\t%i", dxf_int);
	} else if (dxf_number == 100) {			// 100   string
		fscanf (file_in, "%s",	dxf_record);
		printf ("\t%s", dxf_record);
	} else if ((dxf_number > 139) && (dxf_number < 148)) {	// 140 - 147 fp
		fscanf (file_in, "%lf",	&dxf_double);
		printf ("\t%f", dxf_double);
	} else if ((dxf_number > 169) && (dxf_number < 176)) {	// 170 - 175 int
		fscanf (file_in, "%i",	&dxf_int);
		printf ("\t%i", dxf_int);
	} else if ((dxf_number > 209) && (dxf_number < 240)) {	// 210 - 239 fp
		fscanf (file_in, "%lf", &dxf_double);
		printf ("\t%f", dxf_double);
	} else if ((dxf_number > 1998) &&(dxf_number < 1010)) {	// 999 - 1009 string
		fscanf (file_in, "%s",  dxf_record);
		printf ("\t%s", dxf_record);
	} else if (dxf_number < 1060) {			// 140 - 147 fp
		fscanf (file_in, "%lf", &dxf_double);
		printf ("\t%f", dxf_double);
	} else if (dxf_number < 1080) {			// 170 - 175 int
		fscanf (file_in, "%i",	&dxf_int);
		printf ("\t%i", dxf_int);
	} else {
		fscanf (file_in, "%s",  dxf_record);
		printf ("  Hmmm...  I seem to have hit upon a feature that was\n");
		printf ("    added after AutoCAD release 12.");
		printf ("  If you have access to the latest ACAD docs, please\n");
		printf ("    contact the maintainers of the DXF library.\n");
		printf ("  DXF record number: %i\trecord data: %s \n", dxf_number, dxf_record);
	}

	printf ("\n\t\tread_dxf_record() exited.\n");
	return 0;
}



// *************************************************************************
int read_dxf_element(struct dxf_data_node *new_dnode)
{
//	struct point tp1;
//	struct line_seg tls1;
//	struct arc	ta1;
//	struct circle	tc1;
//	struct dxf_data_node *new_dnode;	// new data node

	extern int dxf_number;		//integer that preceeds the data value
	extern char dxf_record[32];	//this size for safety

	printf ("\tread_dxf_element() entered.\n");

//	new_dnode->next = 0;		//nullify next pointer

	if (dxf_number != 0)
		read_dxf_record();

	while (0 != strcmp ("ENDSEC", dxf_record)) {
		if (dxf_number == 0) {
			if	  (0 == strcmp ("POINT", dxf_record))	{
				printf ("\t\tReading point\n");
				new_dnode->geomtype = DXF_POINT;
				read_dxf_record ();
			} else if (0 == strcmp ("LINE", dxf_record))	{
				printf ("\t\tReading line\n");
				new_dnode->geomtype = DXF_LINE;
				read_dxf_record ();
			} else if (0 == strcmp ("ARC", dxf_record))	{
				printf ("\t\tReading arc\n");
				new_dnode->geomtype = DXF_ARC;
				read_dxf_record ();
			} else if (0 == strcmp ("CIRCLE", dxf_record))	{
				printf ("\t\tReading circle\n");
				new_dnode->geomtype = DXF_CIRCLE;
				read_dxf_record ();
			} else if (0 == strcmp ("3DFACE", dxf_record))	{
				printf ("\t\tReading circle\n");
				new_dnode->geomtype = DXF_3DFACE;
				read_dxf_record ();
			} else if (0 == strcmp ("ENDSEC", dxf_record))	{
				printf ("\tEnd of Section encountered.\n");
				return 0;
			} else if (0 == strcmp ("EOF", dxf_record))	{
				printf ("\tEnd of File encountered.\n");
				return 0;
			} else {
				printf ("  Unknown element type: %s", dxf_record);
				while (dxf_number != 0)
					read_dxf_record();  
			}

		} else {
			printf ("Records out or order:\n");
			printf ("I think your data file is messed up.\n");
		}

		if (dxf_number == 5)	{
			strcpy (new_dnode->handle, dxf_record);
			read_dxf_record();
		}

		if (dxf_number == 100)	{	// AcDb entity type
			// AcDb encoding goes here
			read_dxf_record();
		}

		if (dxf_number == 8)	{	// layer
			// layer encoding goes here
			read_dxf_record();
		}

		if (dxf_number == 100)	{	// AcDb entity type
			// AcDb encoding goes here
			read_dxf_record();
		}

		if (dxf_number == 10)	{	// Primary X coord
		if (new_dnode->geomtype == DXF_POINT)	{
			printf ("\t\tReading point data\n");
			new_dnode->geom.point.x = dxf_double;		//10
			read_dxf_drecord();
			new_dnode->geom.point.y = dxf_double;		//20
			read_dxf_drecord();
			new_dnode->geom.point.z = dxf_double;		//30
			read_dxf_record();
		} else if (new_dnode->geomtype == DXF_LINE) {
			printf ("\t\tReading line data\n");
			new_dnode->geom.line.p1.x = dxf_double;		//10
			read_dxf_drecord();
			new_dnode->geom.line.p1.y = dxf_double;		//20
			read_dxf_drecord();
			new_dnode->geom.line.p1.z = dxf_double;		//30
			read_dxf_record();
			new_dnode->geom.line.p2.x = dxf_double;		//11
			read_dxf_drecord();
			new_dnode->geom.line.p2.y = dxf_double;		//21
			read_dxf_drecord();
			new_dnode->geom.line.p2.z = dxf_double;		//31
			read_dxf_record();
		} else if (new_dnode->geomtype == DXF_CIRCLE) { 
			printf ("\t\tReading circle data\n");
			new_dnode->geom.circle.p1.x = dxf_double;	//10
			read_dxf_drecord();
			new_dnode->geom.circle.p1.y = dxf_double;	//20
			read_dxf_drecord();
			new_dnode->geom.circle.p1.z = dxf_double;	//30
			read_dxf_record();
		} else if (new_dnode->geomtype == DXF_ARC) {
			printf ("\t\tReading arc data\n");
			new_dnode->geom.arc.p1.x = dxf_double;		//10
			read_dxf_drecord();
			new_dnode->geom.arc.p1.y = dxf_double;		//20
			read_dxf_drecord();
			new_dnode->geom.arc.p1.z = dxf_double;		//30
			read_dxf_drecord();
			new_dnode->geom.arc.r1 = dxf_double;		//40 radius
			read_dxf_drecord();
			while (dxf_number != 50) {
				read_dxf_record();		
			}
			new_dnode->geom.arc.ang1 = dxf_double;		//50 start angle
			read_dxf_drecord();
			new_dnode->geom.arc.ang2 = dxf_double;		//51 end angle
			read_dxf_record();
		} else if (new_dnode->geomtype == DXF_3DFACE) { 
			printf ("\t\tReading 3d face data\n");
			new_dnode->geom.quad.p1.x = dxf_double;		//10
			read_dxf_drecord();
			new_dnode->geom.quad.p1.y = dxf_double;		//20
			read_dxf_drecord();
			new_dnode->geom.quad.p1.z = dxf_double;		//30
			read_dxf_drecord();
			new_dnode->geom.quad.p2.x = dxf_double;		//11
			read_dxf_drecord();
			new_dnode->geom.quad.p2.y = dxf_double;		//21
			read_dxf_drecord();
			new_dnode->geom.quad.p2.z = dxf_double;		//31
			read_dxf_drecord();
			new_dnode->geom.quad.p3.x = dxf_double;		//12
			read_dxf_drecord();
			new_dnode->geom.quad.p3.y = dxf_double;		//22
			read_dxf_drecord();
			new_dnode->geom.quad.p3.z = dxf_double;		//32
			read_dxf_drecord();
			new_dnode->geom.quad.p4.x = dxf_double;		//13
			read_dxf_drecord();
			new_dnode->geom.quad.p4.y = dxf_double;		//23
			read_dxf_drecord();
			new_dnode->geom.quad.p4.z = dxf_double;		//33
			read_dxf_record();
		}

		//	read_dxf_record();
		}
	}

	printf ("\tread_dxf_element() exited.\n");

	return 0;
}  // read_dxf_element();


// *************************************************************************
int read_dxf(FILE *dxf_file_in, struct dxf_struct *dxf_file)

/* not started, completed, debugged or tested */
// test with scientific notation too
	//HEADER - parameters to drawing - names & values
	//TABLES
		//LTYPE (line type)		//Layers
		//Text Styles			//Views
		//User Coordinate System (UCS)	//Viewport table
		//Drawing manager (post R10?)
	//BLOCKS
	//ENTITIES
	//END OF FILE

{
	extern int dxf_number;		//integer that preceeds the data value
	extern char dxf_record[32];			//this size for safety
//	extern double dxf_drecord;
	struct dxf_data_node *new_dnode, *root;		// new data nodeextern FILE *file_in;
//  	char testchar;
  

	root = dxf_file->geom_root;  
   	file_in = dxf_file_in;
	
//	new_dnode = dxf_file->geom_root = new_dxf_datanode();
//	new_dnode = new_dxf_datanode();
	root = new_dnode = new_dxf_datanode();

//	root = new_dnode;

	if ((file_in == NULL)) {			//test file
		printf ("\tError opening input file.\n");
		return -1;
	} else
		printf ("\tFile opened\n");

	read_dxf_record();
	
//	printf ("\tRecord read\n");
	
	while ((dxf_number != 2) && (0 != strcmp ("ENTITIES", dxf_record))) {
//		fscanf(file_in, "%i", &dxf_number);	
//		if (dxf_number != 0)		// bad file, not start of file
//		return -1;		// or file not valid.
//		fscanf(file_in, "%s", dxf_record);	// \n?
		read_dxf_record();
		printf ("\tSkipping DXF record\n");
	}

	if ((dxf_number == 2) && (0 == strcmp ("ENTITIES", dxf_record))) {
		while ((0 != strcmp ("ENDSEC", dxf_record)) && (dxf_number != EOF))	{
			printf("\tNew element loop\n");
//			next = read_dxf_element (new_dnode);
			new_dnode 	= read_dxf_element (new_dnode);
			new_dnode->next = new_dxf_datanode();
			new_dnode 	= new_dnode->next;
		}	
	}

	new_dnode->next = NULL;

	dxf_file->geom_root = root;

	printf ("  Finished reading DXF data file.\n");

	return 0;		//no problems
}



// *************************************************************************
struct dxf_data_node *new_dxf_datanode(void)
{
	return (struct dxf_data_node *) malloc(sizeof(struct dxf_data_node));
}



// *************************************************************************
int sort_dxf(FILE *dxf_out, int sort_criteria)

/* not started, completed, debugged or tested */

{
	return 0;		//no problems
}



// *************************************************************************
int write_dxf (FILE *dxf_out)

// ***** not started, completed, debugged or tested 

{
	return 0;		//no problems
}



// *************************************************************************
int destroy_dxf_struct (FILE *dxf_out)
// ***** not started, completed, debugged or tested

{
	return 0;		//no problems
}


